#include <sys/types.h>
#include <unistd.h>
#include <errno.h>
#include <assert.h>
#include <stdio.h>
#include <sys/wait.h>
#include <stdlib.h>

int main(int argc, char *argv[]) {
  int result;
  pid_t kid;
  int status;
  kid = vfork();
  if(kid == -1) {
    perror("detach-cterm: Can't fork");
    return 1;
  }
  if(kid == 0) { /* we're the child */
    if(setsid() == -1) {
      perror("detach-cterm: Can't set session ID");
      exit(1);
    }
    if(argc == 1) exit(0);
    result = execvp(argv[1], argv+1);
    assert(result == -1);
    perror("detach-cterm");
    exit(1);
  } else { /* lucky parent */
    if(waitpid(kid, &status, 0) == -1) {
      perror("detach-cterm: Error waiting for child process");
      return 1;
    }
    if(WIFEXITED(status)) exit(WEXITSTATUS(status));
    fprintf(stderr, "detach-cterm: Child exited abnormally\n");
    return 1;
  }
}
